using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using MySqlEFTest.Models;

namespace MySqlEFTest.Controllers
{
    public class ProductController : Controller
    {
        public ProductController() : base()
        {
            var categoryRepo = new CategoryRepository();
            ViewData["categories"] = categoryRepo.Select().ToList();
        }

        //
        // GET: /Product/

        public ActionResult Index()
        {
            ProductRepository productRepository = new ProductRepository();

            return View(productRepository.Select().ToList());
        }

        //
        // GET: /Product/Details/5

        public ActionResult Details(int id)
        {
            ProductRepository productRepository = new ProductRepository();

            var product = productRepository.Select(id);

            return View(product);
        }

        //
        // GET: /Product/Create

        public ActionResult Create()
        {
            return View();
        } 

        //
        // POST: /Product/Create

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Create(FormCollection formCollection)
        {
            try
            {
                Product product = new Product();
                TryUpdateModel(product);

                var productRepo = new ProductRepository();
                productRepo.Add(product);
                productRepo.Save();

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        //
        // GET: /Product/Edit/5
 
        public ActionResult Edit(int id)
        {           
            var productRepo = new ProductRepository();
            var product = productRepo.Select(id);

            return View(product);
        }

        //
        // POST: /Product/Edit/5

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                var productRepo = new ProductRepository();
                var product = productRepo.Select(id);

                TryUpdateModel(product);

                productRepo.Save();
 
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }
    }
}
