﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace MySqlEFTest.Models
{
    public class ProductRepository 
    {            
        MySQLEntities mySqlEntities = new MySQLEntities();

        public IQueryable<Product> Select()
        {
            var result = from p in mySqlEntities.ProductSet
                         select p;

            return result;
        }

        public Product Select(int id)
        {
            var result = from p in Select()
                         where p.id == id
                         select p;

            return result.First();
        }

        public void Add(Product product)
        {
            mySqlEntities.AddToProductSet(product);
        }

        public void Delete(Product product)
        {
            mySqlEntities.DeleteObject(product);
        }

        public void Save()
        {
            mySqlEntities.SaveChanges();
        }
    }

    public partial class Product
    {
        private Category _category;

        public Category Category
        {
            get
            {
                if (_category == null)
                {
                    var categoryRepository = new CategoryRepository();

                    var cat = categoryRepository.Select(categoryid);

                    _category = cat.First();
                }

                return _category;
            }

        }
        
    }
}
